##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic compression utilities                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate the generation of          ##
## compressed files and their inclusion in users' projects.               ##
############################################################################

## COMPRESSION EXAMPLE (Uncomment lines to use)
##

## First 3 calls to ADD2PACK add enemy, hero and background
## graphics (previously converted to binary data) into the 
## compressed group 'mygraphics'. After that, call to PACKZX7B
## compresses all the data and generates an array with the result
## that is placed in src/mygraphics.c & src/mygraphics.h, ready
## to be included and used by other modules.
##
#$(eval $(call ADD2PACK,mygraphics,gfx/enemy.bin))
#$(eval $(call ADD2PACK,mygraphics,gfx/hero.bin))
#$(eval $(call ADD2PACK,mygraphics,gfx/background.bin))
#$(eval $(call PACKZX7B,mygraphics,src/))

$(eval $(call ADD2PACK,lvl0_pack,src/maps/lvl0/lvl0.bin))
$(eval $(call ADD2PACK,lvl0_pack,src/maps/map_tiles/tiles.bin))
$(eval $(call PACKZX7B,lvl0_pack,src/maps/lvl0))

$(eval $(call ADD2PACK,lvl1_pack,src/maps/lvl1/lvl1.bin))
$(eval $(call PACKZX7B,lvl1_pack,src/maps/lvl1))

$(eval $(call ADD2PACK,lvl2_pack,src/maps/lvl2/lvl2.bin))
$(eval $(call PACKZX7B,lvl2_pack,src/maps/lvl2))

$(eval $(call ADD2PACK,lvl3_pack,src/maps/lvl3/lvl3.bin))
$(eval $(call PACKZX7B,lvl3_pack,src/maps/lvl3))

$(eval $(call ADD2PACK,lvl4_pack,src/maps/lvl4/lvl4.bin))
$(eval $(call PACKZX7B,lvl4_pack,src/maps/lvl4))

$(eval $(call ADD2PACK,lvl5_pack,src/maps/lvl5/lvl5.bin))
$(eval $(call PACKZX7B,lvl5_pack,src/maps/lvl5))

$(eval $(call ADD2PACK,lvl6_pack,src/maps/lvl6/lvl6.bin))
$(eval $(call PACKZX7B,lvl6_pack,src/maps/lvl6))

$(eval $(call ADD2PACK,lvl7_pack,src/maps/lvl7/lvl7.bin))
$(eval $(call PACKZX7B,lvl7_pack,src/maps/lvl7))

$(eval $(call ADD2PACK,lvl8_pack,src/maps/lvl8/lvl8.bin))
$(eval $(call PACKZX7B,lvl8_pack,src/maps/lvl8))

$(eval $(call ADD2PACK,lvl9_pack,src/maps/lvl9/lvl9.bin))
$(eval $(call PACKZX7B,lvl9_pack,src/maps/lvl9))

$(eval $(call ADD2PACK,lvl10_pack,src/maps/lvl10/lvl10.bin))
$(eval $(call PACKZX7B,lvl10_pack,src/maps/lvl10))

$(eval $(call ADD2PACK,lvl11_pack,src/maps/lvl11/lvl11.bin))
$(eval $(call PACKZX7B,lvl11_pack,src/maps/lvl11))

$(eval $(call ADD2PACK,lvl12_pack,src/maps/lvl12/lvl12.bin))
$(eval $(call PACKZX7B,lvl12_pack,src/maps/lvl12))

$(eval $(call ADD2PACK,lvl13_pack,src/maps/lvl13/lvl13.bin))
$(eval $(call PACKZX7B,lvl13_pack,src/maps/lvl13))

$(eval $(call ADD2PACK,lvl14_pack,src/maps/lvl14/lvl14.bin))
$(eval $(call PACKZX7B,lvl14_pack,src/maps/lvl14))

$(eval $(call ADD2PACK,lvl15_pack,src/maps/lvl15/lvl15.bin))
$(eval $(call PACKZX7B,lvl15_pack,src/maps/lvl15))

$(eval $(call ADD2PACK,lvl16_pack,src/maps/lvl16/lvl16.bin))
$(eval $(call PACKZX7B,lvl16_pack,src/maps/lvl16))

$(eval $(call ADD2PACK,lvl17_pack,src/maps/lvl17/lvl17.bin))
$(eval $(call PACKZX7B,lvl17_pack,src/maps/lvl17))

$(eval $(call ADD2PACK,lvl18_pack,src/maps/lvl18/lvl18.bin))
$(eval $(call PACKZX7B,lvl18_pack,src/maps/lvl18))

$(eval $(call ADD2PACK,lvl19_pack,src/maps/lvl19/lvl19.bin))
$(eval $(call PACKZX7B,lvl19_pack,src/maps/lvl19))

$(eval $(call ADD2PACK,lvl20_pack,src/maps/lvl20/lvl20.bin))
$(eval $(call PACKZX7B,lvl20_pack,src/maps/lvl20))

$(eval $(call ADD2PACK,lvl21_pack,src/maps/lvl21/lvl21.bin))
$(eval $(call PACKZX7B,lvl21_pack,src/maps/lvl21))

$(eval $(call ADD2PACK,lvl22_pack,src/maps/lvl22/lvl22.bin))
$(eval $(call PACKZX7B,lvl22_pack,src/maps/lvl22))

$(eval $(call ADD2PACK,lvl23_pack,src/maps/lvl23/lvl23.bin))
$(eval $(call PACKZX7B,lvl23_pack,src/maps/lvl23))

$(eval $(call ADD2PACK,lvl24_pack,src/maps/lvl24/lvl24.bin))
$(eval $(call PACKZX7B,lvl24_pack,src/maps/lvl24))

$(eval $(call ADD2PACK,lvl25_pack,src/maps/lvl25/lvl25.bin))
$(eval $(call PACKZX7B,lvl25_pack,src/maps/lvl25))

$(eval $(call ADD2PACK,lvl26_pack,src/maps/lvl26/lvl26.bin))
$(eval $(call PACKZX7B,lvl26_pack,src/maps/lvl26))

$(eval $(call ADD2PACK,lvl27_pack,src/maps/lvl27/lvl27.bin))
$(eval $(call PACKZX7B,lvl27_pack,src/maps/lvl27))

$(eval $(call ADD2PACK,lvl28_pack,src/maps/lvl28/lvl28.bin))
$(eval $(call PACKZX7B,lvl28_pack,src/maps/lvl28))

$(eval $(call ADD2PACK,lvl29_pack,src/maps/lvl29/lvl29.bin))
$(eval $(call PACKZX7B,lvl29_pack,src/maps/lvl29))

$(eval $(call ADD2PACK,lvl30_pack,src/maps/lvl30/lvl30.bin))
$(eval $(call PACKZX7B,lvl30_pack,src/maps/lvl30))

$(eval $(call ADD2PACK,lvl31_pack,src/maps/lvl31/lvl31.bin))
$(eval $(call PACKZX7B,lvl31_pack,src/maps/lvl31))

$(eval $(call ADD2PACK,lvl32_pack,src/maps/lvl32/lvl32.bin))
$(eval $(call PACKZX7B,lvl32_pack,src/maps/lvl32))

$(eval $(call ADD2PACK,lvl33_pack,src/maps/lvl33/lvl33.bin))
$(eval $(call PACKZX7B,lvl33_pack,src/maps/lvl33))

$(eval $(call ADD2PACK,lvl34_pack,src/maps/lvl34/lvl34.bin))
$(eval $(call PACKZX7B,lvl34_pack,src/maps/lvl34))

$(eval $(call ADD2PACK,lvl35_pack,src/maps/lvl35/lvl35.bin))
$(eval $(call PACKZX7B,lvl35_pack,src/maps/lvl35))

$(eval $(call ADD2PACK,lvl36_pack,src/maps/lvl36/lvl36.bin))
$(eval $(call PACKZX7B,lvl36_pack,src/maps/lvl36))

$(eval $(call ADD2PACK,lvl37_pack,src/maps/lvl37/lvl37.bin))
$(eval $(call PACKZX7B,lvl37_pack,src/maps/lvl37))

$(eval $(call ADD2PACK,comenzacion_pack,src/fondo/comenzacion.bin))
$(eval $(call PACKZX7B,comenzacion_pack,src/fondo))

$(eval $(call ADD2PACK,perecer_pack,src/fondo/perecer.bin))
$(eval $(call PACKZX7B,perecer_pack,src/fondo))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macros used for compression are ADD2PACK and PACKZX7B:                 ##
##                                                                        ##
##	ADD2PACK: Adds files to packed (compressed) groups. Each call to this ##
##  		  macro will add a file to a named compressed group.          ##
##  PACKZX7B: Compresses all files in a group into a single binary and    ##
##            generates a C-array and a header to comfortably use it from ##
##            inside your code.                                           ##
##                                                                        ##
##------------------------------------------------------------------------##
##                                                                        ##
##  $(eval $(call ADD2PACK,<packname>,<file>))                            ##
##                                                                        ##
##		Sequentially adds <file> to compressed group <packname>. Each     ##
## call to this macro adds a new <file> after the latest one added.       ##
## packname could be any valid C identifier.                              ##
##                                                                        ##
##  Parameters:                                                           ##
##  (packname): Name of the compressed group where the file will be added ##
##  (file)    : File to be added at the end of the compressed group       ##
##                                                                        ##
##------------------------------------------------------------------------##
##                                                                        ##
##  $(eval $(call PACKZX7B,<packname>,<dest_path>))                       ##
##                                                                        ##
##		Compresses all files in the <packname> group using ZX7B algorithm ##
## and generates 2 files: <packname>.c and <packname>.h that contain a    ##
## C-array with the compressed data and a header file for declarations.   ##
## Generated files are moved to the folder <dest_path>.                   ##
##                                                                        ##
##  Parameters:                                                           ##
##  (packname) : Name of the compressed group to use for packing          ##
##  (dest_path): Destination path for generated output files              ##
##                                                                        ##
############################################################################
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##  * You can omit parameters by leaving them empty.                      ##
##  * Parameters (4) and (5) are optional and generally not required.     ##
############################################################################
