
.include "generic_operations.h.s"
.include "maps/lvl0/lvl0.h.s"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: obtiene el puntero en tiles para la posicion en X
;;NECESITA: B (dividendo), A(divisor)
;;MODIFICA: B, A
;;RETURNS: B (cociente de la divison), A (A>0 si hay resto, A=0 si no)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
division:

    cp #4
    jr nz, div_4
        ld a ,#00
        srl b
        adc #0
        srl b
        adc #0
        ret
    div_4:

    cp #8
    jr nz, div_8
        ld a, #00
        srl b
        adc #0
        srl b
        adc #0
        srl b
        adc #0
        ret
    div_8:

    cp #2
    jr nz, div_2 
        ld a, #00
        srl b
        adc #0
        ret
    div_2:


;;;;;;;DANGER--------------------------------------------------------------
;;;;;;;DANGER--------------------------------------------------------------
;;;;;;;DANGER--------------------------------------------------------------
;;;;;;;DANGER--------------------------------------------------------------
;;;;;;;;;;;;;;;DIVISION GENERICA COPIADA DE INTERNET;;;;;;;;;;;;;;;;;;;;;;;
    ld e, b
    ld c, a
    ; In: Divide E by divider C
    ; Out: A = result, B = rest
        xor a
        ld b,#8
    Div8_Loop:
        rl e
        rla
        sub c
        jr nc,Div8_NoAdd
        add a,c
    Div8_NoAdd:
        djnz Div8_Loop
        ld b,a
        ld a,e
        rla
        cpl
    ld c, a
    ld a, b
    ld b, c
ret
;;;;;;;;;;;;;;;DIVISION GENERICA COPIADA DE INTERNET;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Divide 16-bit values (with 16-bit result)
;; In: Divide BC by divider DE
;; Out: BC = result, HL = rest
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
div16:
    ld hl,#0
    ld a,b
    ld b,#8
Div16_Loop1:
    rla
    adc hl,hl
    sbc hl,de
    jr nc,Div16_NoAdd1
    add hl,de
Div16_NoAdd1:
    djnz Div16_Loop1
    rla
    cpl
    ld b,a
    ld a,c
    ld c,b
    ld b,#8
Div16_Loop2:
    rla
    adc hl,hl
    sbc hl,de
    jr nc,Div16_NoAdd2
    add hl,de
Div16_NoAdd2:
    djnz Div16_Loop2
    rla
    cpl
    ld b,c
    ld c,a
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: obtiene el puntero en tiles para la posicion en Y
;;NECESITA: E posicion en y, D posicion en x
;;MODIFICA: DE, BC
;;RETURNS: HL (posicion de memoria del tile)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

multiplicacion:
        ;carga previa
            ld hl , #0000
            ld bc, #_lvl0_W
        ;comprobamos que la y no es 0 
        dec e
        inc e
        jr z, resul

        ;multiplicamos bc por e ancho del mapa* Y y lo ponemos en HL
        mult:

            add hl, bc
            dec e

        jr z, resul
        jr mult

        ;;sumamos a hl E que coniene la posicion X
        resul:
        ld e, d
        ld d, #00
        add hl, de
ret
