;INCLUDES
.include "cpctelera.h.s"
.include "man_game.h.s"
.include "man_entity.h.s"
.include "man_maps.h.s"
.include "../sfx.h.s"
.include "../cpct_header.h.s"
.include "../systems/sys_ai.h.s"
.include "../systems/sys_state.h.s"
.include "../systems/sys_input.h.s"
.include "../systems/sys_physics.h.s"
.include "../systems/sys_render.h.s"
.include "../systems/sys_collisions.h.s"
.include "../systems/sys_animations.h.s"
.include "../systems/sys_hud.h.s"

.globl my_draw_string
.globl _main_music

gronf: .asciz "GRONF GRONF";
mmh: .asciz "MMMMMMHHHH!!";
lifes: .dw #0000
timer: .dw #0000

music: .db #00

;act_hud: .dw #0000
halt_counter: .dw #0000
halt_counter_music: .db #06

interrupciones::
;    ld hl, #0
;    ld (#act_hud), hl
    ld a, (#halt_counter_music)
    dec a
    ld (#halt_counter_music), a
    jr nz, no_play_

        ld a, #6
        ld (#halt_counter_music), a
        
        ex af, af'
        exx
        push af
        push hl
        push bc
        push de

        ld a, (music)
        cp #0
        jr nz, return

        call cpct_akp_musicPlay_asm

        return:
        pop de
        pop bc
        pop hl
        pop af
        exx
        ex af, af'

    no_play_:

    ld hl, (#halt_counter)
    inc hl
    ld (#halt_counter), hl
    dec h 
    inc h
ret z
    ld a, l
    cp #0x2C
ret nz
;    ld hl, #1
;    ld (#act_hud), hl
    ld a,#0
    ld (#halt_counter),a
    ld (#halt_counter+1), a
    ld hl, (#timer)
    inc hl
    ld (#timer), hl

ret

no_interrupt:
    ld a, (#halt_counter_music)
    dec a
    ld (#halt_counter_music), a
    jr nz, no_play_2

        ld a, #6
        ld (#halt_counter_music), a
        
        ex af, af'
        exx
        push af
        push hl
        push bc
        push de

        ld a, (music)
        cp #0
        jr nz, return2

        call cpct_akp_musicPlay_asm

        return2:
        pop de
        pop bc
        pop hl
        pop af
        exx
        ex af, af'

    no_play_2:
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION: carga el juego por pimera vez poniendo el estado 
;;             a 0 (pantalla de inicio)//IT PROBABLY WILL HAVE TO DO MUCH MORE
;;NEEDS:       -
;;DESTROYS:    A
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
man_game_init:
    call load_maps
    call sys_hud_init
    call man_entity_init
ret	

man_game_update:
    ld hl, #interrupciones
    call cpct_setInterruptHandler_asm

    re_loop_:
    call man_entity_update
    call sys_input

    ;++++++++++++++++++++++++++++++++++++++++++++++;

    ;;THIS IS FOR TESTING DELETE FOR FINAL GAME;;

    ;++++++++++++++++++++++++++++++++++++++++++++++;

    dec a
    jr nz, no_win2

        ld a, (contador_mapas)      ;; cargamos el contador de mapas
        inc a
        ld (contador_mapas), a

        ld de, #total_map_size
        ld iy, (#map_data)
        add iy, de
        
        ld l, 4(iy) 
        ld h, 5(iy)
        ld (compressed_maps), hl

        call man_entity_map_data

        ld hl, #no_interrupt
        call cpct_setInterruptHandler_asm

        ld a, (#contador_mapas)
        ret

    no_win2:

    ;-----------------------------------------------;

    ;;THIS IS FOR TESTING DELETE FOR FINAL GAME;;

    ;-----------------------------------------------;

    call sys_ai

    ;;;;COMPUEBA VICTORIA;;;;
    call sys_collisions_win
    dec a
    jr nz, no_win

        ld hl, #no_interrupt
        call cpct_setInterruptHandler_asm

        ld a, (#contador_mapas)
        ret

    no_win:
    ;;;;COMPUEBA VICTORIA;;;;
    ;;;;COMPUEBA DERROTA;;;;
    
    call calc_colisiones_entity     ;; Calcula las colisiones del jugador con TODAS las entidades
    dec a
    jr nz, no_lose
        push af
        ld a, #4
        call play_sound
        pop af
        
        call gronf_gronf
        ld a, (#lifes)
        inc a
        ld (#lifes), a
        ld hl, #no_interrupt
        call cpct_setInterruptHandler_asm
        ld a, (#mapas_totales)
        inc a
        ret
    no_lose:
    ;;;;COMPUEBA DERROTA;;;;
    call sys_collisions 
    call sys_animations
    call sys_physics
    ld hl, #31
      ld (#mapas_totales), hl
    call sys_hud_update

    ld a, (game_options)
    dec a
    dec a
    jr z, gotta_go_fast

    ld a, #7
    wait:
        dec a
        halt
    jr nz, wait

    gotta_go_fast:
    call cpct_waitVSYNC_asm
     ;;hay que borrar despues de las fisicas por que si no habran parpadeos
    call pintar_enemy

    jp re_loop_
ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION: escribe en en pantalla GRONF GRONF MMMMMMHHHH!!
;;NEEDS: -
;;DESTROYS: HL, A
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
gronf_gronf:
    ld l, #0x0C
    ld h, #0
    call cpct_setDrawCharM0_asm


    ld iy, #gronf
       ;*******************SCREEN POS********************************************
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld    b, e_y(ix)                ;; B = y coordinate (24 = 0x18)
    ld    c, #20               ;; C = x coordinate (16 = 0x10)
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
    ;**************************************************************************
    call my_draw_string  ;; Draw the string
    ld a, #255
    wait_:
        dec a
        halt
    jr nz, wait_

    ld ix, #player
    ld iy, #mmh
           ;*******************SCREEN POS********************************************
    ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld    b, e_y(ix)                ;; B = y coordinate (24 = 0x18)
    ld    c, #20                 ;; C = x coordinate (16 = 0x10)
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
    ;**************************************************************************
    call my_draw_string  ;; Draw the string
    ld a, #255
    wait_2:
        dec a
        halt
    jr nz, wait_2


ret