.include "cpctelera.h.s"
.include "sys_ai.h.s"
.include "../managers/man_maps.h.s"
.include "../managers/man_entity.h.s"
.include "sys_collisions.h.s"
.include "../cpct_header.h.s"

.include "../generic_operations.h.s"
.include "sys_render.h.s"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION: calcula hacia donde tiene que moverse la ia
;;NEEDS:       -
;;DESTROYS:    DE, HL, A
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

sys_ai:

    ld ix, #player
    ld a, (#entity_num)
    ld b, a
    update_next:
        ld de, #entity_size
        add ix, de

        ld a, e_nk_r(ix)
        cp #0
        jr z, jump
            push bc
                call calculo_IA
            pop bc
        jump:
    djnz update_next
ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION: calcula la velocidad que tiene que tener la entidad de ia
;;NEEDS:       
;;DESTROYS:    A,HL, DE, BC
;;RETURNS:     
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
calculo_IA:
    call comprobar_lado

    ld h, e_mid_x(ix)
    ld l, e_mid_y(ix)
    dec h
    inc h
    jp nz, end_ia_
    dec l
    inc l
    jp nz, end_ia_

        call get_last_tile ;obtengo en a la direccion de la que vengo y tengo que ignorar
        ld e , a
        call get_viable_paths ; guardo las direcciones diponibles 4b E y el numero de caminos disponibles D
        ;;-----check number of paths----
        ld a, #0
        cp d
        jr z, turn_arround
        dec d
        jr z, just_one_path
            call get_player_path
            call get_random_path ;returns A (path to go NUMBER);
            jr lets_move
        
        just_one_path:
        ld a, e
        jr lets_move

        turn_arround:
            call get_last_tile
        lets_move:
        ;------mueve--------
        call move_to_path; path in a

    end_ia_:
ret	


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION: calcula la direccion de la que viene para no volver por donde ha venido
;;NEEDS:       
;;DESTROYS:    HL
;;RETURNS:     A(direccion al bloque malo 4b) 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
get_last_tile:
    
    ld h, e_prev_vx(ix)
    ld l, e_prev_vy(ix)

    dec h
    jr nz, no_der
        ld a, #4
        ret
    no_der:
    inc h
    jr z, no_izq
        ld a, #1
        ret
    no_izq:
    dec l
    dec l
    jr nz, no_aba
        ld a, #8
        ret
    no_aba:
    ld a, #2
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION: calcula las direciones disponibles y el numero de estos fromato 4 bits
;;NEEDS:       E (caminos 4b)
;;DESTROYS:    HL, DE,BC, A
;;RETURNS:     D (numero de caminos), E(caminos formato 4 bits)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
get_viable_paths:

    ld d ,#0xFF
    ;-----------derecha------------
    ld a, #00
    call get_adyacent_tile ;modifica HL, BC, A
    ld a, (hl)
    cp #16              ;; numero de tile a partir del cual pueden colisionar
    jr nc, col_r ;;si el bloque a la derecha es zero es que hay colision, conlo que no lo apunto
        
        ;;comprobamos si los bloques son puertas para eliminarlos de los posibles caminos

        cp #3           ;; puerta amarilla
        jr z, col_r

        cp #6           ;; puerta roja
        jr z, col_r

        cp #9           ;; puerta azul
        jr z, col_r

        cp #12          ;; puerta verde
        jr z, col_r
        
        ld a, #1
        xor e
        ld e, a
        inc d

    col_r:

    ;-----------abajo------------
    ld a, #1
    call get_adyacent_tile
    ld a, (hl)
    cp #16
    jr nc, col_d

        ;;comprobamos si los bloques son puertas para eliminarlos de los posibles caminos

        cp #3           ;; puerta amarilla
        jr z, col_d

        cp #6           ;; puerta roja
        jr z, col_d

        cp #9           ;; puerta azul
        jr z, col_d

        cp #12          ;; puerta verde
        jr z, col_d

        ld a, #2
        xor e
        ld e, a
        inc d
    col_d:
    ;-----------izquierdo------------
    ld a, #2
    call get_adyacent_tile
    ld a, (hl)
    cp #16
    jr nc, col_l

        ;;comprobamos si los bloques son puertas para eliminarlos de los posibles caminos

        cp #3           ;; puerta amarilla
        jr z, col_l

        cp #6           ;; puerta roja
        jr z, col_l

        cp #9           ;; puerta azul
        jr z, col_l

        cp #12          ;; puerta verde
        jr z, col_l


        ld a, #4
        xor e
        ld e, a
        inc d
    col_l:

    ;-----------arriba------------
    ld a, #3
    call get_adyacent_tile
    ld a, (hl)
    cp #16
    jr nc, col_u

        ;;comprobamos si los bloques son puertas para eliminarlos de los posibles caminos

        cp #3           ;; puerta amarilla
        jr z, col_u

        cp #6           ;; puerta roja
        jr z, col_u

        cp #9           ;; puerta azul
        jr z, col_u

        cp #12          ;; puerta verde
        jr z, col_u


        ld a, #8
        xor e
        ld e, a
        inc d
    col_u:
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION: obtiene el camino mas prioritario de los disponibles
;;NEEDS:       IX (enemy) DE (number of paths and possible paths)
;;DESTROYS:    IY, BC, HL, A
;;RETURNS:     A (4b player_path)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
get_player_path::
    ld iy, #player
    ;;X;;
    ld a, e_x(ix)
    ld b, e_x(iy)
    sub b
    ld c, a ;;C el valor de ofset horizontal del player respecto al enemy
    jr nc, negative_x
        ld h, #0 ;;H si esta a la izquierda esto es 1
        sla c
        sub c
        ld c, a
        jr no_negative_x
    negative_x: 
        ld h, #1 ;;H su esta a la derecha esto es 0
    no_negative_x:
    ;;Y;;
    ld a, e_y(ix)
    ld b, e_y(iy)
    sub b
    ld b, a ;;B el valor de ofset vertical del player respecto al enemy
    jr nc, negative_y
        ld l, #0 ;;L si esta arriba esto es 1
        sla b
        sub b
        ld b, a
        jr no_negative_y
    negative_y: 
        ld l, #1 ;;L si esta abajo esto es 0
    no_negative_y:

    ;H(0 der, 1 izq)        L(0 arriba, 1 abajo)
    ;C(cantidad offset X)   B(cantidad offset Y)

    ld a, #2
    call division
    ;;NECESITA: B (dividendo), A(divisor)
    ;;MODIFICA: B, A
    ;;RETURNS: B (cociente de la divison), A (A>0 si hay resto, A=0 si no)
        
    
    ld a, c
    sub b
    jr nc, x_the_wae
    y_the_wae:
        dec l
        jr z, taparriba
            ;tapabajo
            ld a, #2
            call check_avilable
            cp #0
            jr z, x_the_wae
            jr done
        taparriba:
            ;taparriba
            inc l
            inc l
            ld a, #8
            call check_avilable
            cp #0
            jr z, x_the_wae
            jr done
    x_the_wae:
        dec h
        jr z, tapaizquierda
            ;tapaderecha
            ld a, #1
            call check_avilable
            cp #0
            jr z, y_the_wae
            jr done
        
        tapaizquierda:
            ;tapaizquierda
            ld a, #4
            call check_avilable
            cp #0
            jr z, y_the_wae
            inc h
            inc h

    done:
ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION: cheks if the path is avilable 
;;NEEDS:       A (path to check), E (avilable paths)
;;DESTROYS:    A, HL, B
;;RETURNS:     A(0 NOT avilable, PATH -> avilable)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
check_avilable:
    
    and e
    jr z, not_avilable
        ;;avilable
        ret  
    not_avilable:
    ld a, #0
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION: obtiene un nuemro bit aleatoria ente el primero y el 4 y comprueba qeu es valido en nuestro caso(esto ultimo habra que sacarlo de aqui)
;;NEEDS:       E (camnios diponibles), A (camino predilecto)
;;DESTROYS:    A, HL, B
;;RETURNS:     A(caminos 4B)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
get_random_path:
    ;------------randomiza------------
    ld h, a ;;en H el camino predilecto

    ld a, e_nk_r(ix)
    cp #8
    jr z, must_go_random

    ld a, e_rand_seal(ix)
    cp #0
    jr nz, dec_seal
    jr must_go_random
    dec_seal:
        dec a
        ld e_rand_seal(ix),a
        jr preferido
    must_go_random:
    ld l, #0
    call cpct_getRandom_lcg_u8_asm
    ld b, e_nk_y(ix) ;;este valor sera la probabilidad de eleir el camino bueno
    sub b
    ld b, a 
    ld l, a
    jr nc, no_preferido
        preferido:
        ld a, h         ;;devuelvo h que es el camino preferia
        ret
    no_preferido:

        
    ld a, #4
    ld e_rand_seal(ix), a

    ld a, e         ;;xor de los caminos posibles con el camino predilecto para eliminarlo de los posibles
    xor h
    ld e, a;;suponogo que hara falta----------
    dec d
    jr nz, two_paths
        ret ;;si lo quedaba un camino lo duelve
    two_paths: ;;se viene la movida
    ld a, #2
    call division ;B dividendo viene cargado de arriba
    ld a, l ;;en L esta el numero aleatorio ya con la resta del camino predilecto, al cual le tengo que restar lo que hay en B y comprobar el carry
    inc b
    sub b
    jr nc, no_1
        ld h, #0x01
        jr transform_path
    no_1:
        ld h, #0x02

    transform_path:
    ld a, #1
    next_try:
        ld l, a
        and e
        jr z, no_valido
            dec h
            ret z
        no_valido:
        ld a, l
        sla a
    jr next_try
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION: teniendo un camino en 4B se mueve hacia el
;;NEEDS:       A (camino al que moverse)
;;DESTROYS:    A
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
move_to_path:
    srl a
    jr nz, no_right
        ld e_vy(ix), #0
        ld e_vx(ix), #1
        ret
    no_right:
    srl a
    jr nz, no_down
        ld e_vy(ix), #2
        ld e_vx(ix), #0
        ret
    no_down:
    srl a
    jr nz, no_left
        ld e_vy(ix), #0
        ld e_vx(ix), #-1
        ret
    no_left:
    ld e_vy(ix), #-2
    ld e_vx(ix), #0
ret

draw_key:

    call get_adyacent_tile              ;; esto me calcula el tile siguiente al que me voy a mover

        ld d, a
        ld a, (hl)


        call comprobar_llave

        call fake_key

ret

comprobar_lado:

    ld d , e_mid_x(ix)                     ;; cargamos en del carry de x
    dec d
    inc d                                  ;; lo decrementamos para saber si es 0 o no
    jr	nz, end_x2                           ;; si es 0 saltamos el codigo de X

    ld d, e_mid_y(ix)                      ;; cargo en d el carry del eje Y
    dec d
    inc d                                  ;; lo decremento para activar el flag z
    jr nz, end_x2                          ;; si esto es cero cambio la velocidad del eje x a 0

    ld a, e_vx(ix)                         ;;selecciono a de movimiento en x
    dec a
    inc a
    jr z, end_x2
    jp m, no_right2
        ;;;;; DERECHAAAAAAA ;;;;;
        ld a, #0x02
        call draw_key
        jr end_x2                                ;;aqui es innecesario por que hay ret pero si nos movemos a la derecha no podemos movernos a la izquierdo

    no_right2:
        ;;;;; IZQUIERDAAAAAAA ;;;;;
        ld a, #0x00
        call draw_key
        jr end_x2

    end_x2:

;;comprobamos eje y

    ld d, e_mid_y(ix)                     ;; cargamos en d el primero de los carrys
    dec d    
    inc d                        ;; lo decrementamos para saber si es 0 o no
    jr	nz, end_y2                     ;; si es 0 saltamos el codigo de Y

    ld d, e_mid_x(ix)                      ;; cargo en d el carry de el eje X
    dec d   
    inc d                        ;; lo decremento para activar el flag z
    jr nz, end_y2                ;; si esto es cero cambio la velocidad del eje x a 0

    ld a, e_vy(ix)                  ;;selecciono a de movimiento en x
    dec a
    inc a
    jr z, end_y2
    jp m, no_down2

    ;;;;; ABAJOOOOOOOOOOOO ;;;;;
        ld a, #0x03
        call draw_key
        jr end_y2

    no_down2:
    ;;;;; ARRIBAAAAAAAAAA ;;;;;
        ld a, #0x01
        call draw_key
        jr end_y2

    end_y2:

ret



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION: comprueba que llave hay en el suelo y repinta la de su mismo color
;;NEEDS:       A
;;DESTROYS:    DE, HL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


comprobar_llave:


    cp #2                       ;; compruebo que la llave es amarilla
    jr nz, no_y_key


        ld a, d

        ld de, #0xC000                      ;; cargo la posicion de memoria donde empieza la memoria de video
        call get_adyacent_tile_bytes        ;; calculo el tile que quiero pintar en bytes

        call cpct_getScreenPtr_asm          ;; cojo la posicion de memoria de video del enemigo
        
        ex de, hl

        ld hl, #tile_key_y                  ;; cargo la posicion donde esta el tile que quiero pintar
        call cpct_drawTileAligned4x8_asm    ;; pinto el tile seleccionado


        jr no_key

    no_y_key:


    cp #5                       ;; compruebo que la llave es roja
    jr nz, no_r_key


        ld a, d

        ld de, #0xC000                      ;; cargo la posicion de memoria donde empieza la memoria de video
        call get_adyacent_tile_bytes        ;; calculo el tile que quiero pintar en bytes

        call cpct_getScreenPtr_asm          ;; cojo la posicion de memoria de video del enemigo
        
        ex de, hl

        ld hl, #tile_key_r                  ;; cargo la posicion donde esta el tile que quiero pintar
        call cpct_drawTileAligned4x8_asm    ;; pinto el tile seleccionado



        jr no_key

    no_r_key:


    cp #8                       ;; compruebo que la llave es azul
    jr nz, no_b_key


        ld a, d

        ld de, #0xC000                      ;; cargo la posicion de memoria donde empieza la memoria de video
        call get_adyacent_tile_bytes        ;; calculo el tile que quiero pintar en bytes

        call cpct_getScreenPtr_asm          ;; cojo la posicion de memoria de video del enemigo
        
        ex de, hl

        ld hl, #tile_key_b                  ;; cargo la posicion donde esta el tile que quiero pintar
        call cpct_drawTileAligned4x8_asm    ;; pinto el tile seleccionado


        jr no_key

    no_b_key:


    cp #11                      ;; compruebo que la llave es verde
    jr nz, no_g_key

        ld a, d

        ld de, #0xC000                      ;; cargo la posicion de memoria donde empieza la memoria de video
        call get_adyacent_tile_bytes        ;; calculo el tile que quiero pintar en bytes

        call cpct_getScreenPtr_asm          ;; cojo la posicion de memoria de video del enemigo
        
        ex de, hl

        ld hl, #tile_key_g                  ;; cargo la posicion donde esta el tile que quiero pintar
        call cpct_drawTileAligned4x8_asm    ;; pinto el tile seleccionado

        jr no_key

    no_g_key:

    no_key:

ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION: comprueba que el tile en el suelo es el seleccionado para que el enemigo cree una llave false
;;NEEDS:       A
;;DESTROYS:    DE, HL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

fake_key:

    cp #14

    jr nz, no_fake_key

        ;; PUEDO CAMBIAR ESTO PARA PASARLE A COMPROBAR_LLAVE EN A LA LLAVE DEL COLOR QUE QUIERO REPINTAR

        ld a, d

        ld de, #0xC000                      ;; cargo la posicion de memoria donde empieza la memoria de video
        call get_adyacent_tile_bytes        ;; calculo el tile que quiero pintar en bytes

        call cpct_getScreenPtr_asm          ;; cojo la posicion de memoria de video del enemigo
        
        ex de, hl

        ld hl, #tile_key_y                  ;; cargo la posicion donde esta el tile que quiero pintar
        call cpct_drawTileAligned4x8_asm    ;; pinto el tile seleccionado

    no_fake_key:

ret