;;Includes
.include "../managers/man_game.h.s"
.include "../managers/man_entity.h.s"
.include "../cpct_header.h.s"
.include "sys_animations.h.s"


last_sprite: .dw #0000
last_sprite_Enemigo: .dw #0000
contador: .dw #0004
contadorEnemigo: .dw #0004

;; LA COSA QUE MODIFIQUE EL PLAYER TIENE QUE ESTAR EN EL MANAGER DEL PLAYER 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: Genera las animaciones del sprite del player
;;NECESITA: IX (direccion al jugador)
;;MODIFICA: HL, BC, DE, A
;;RETURNS: C (numero del sprite que debe cargar)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


sys_animations:

    call sys_animations_player
    
    ld hl, (contadorEnemigo)                        ;; Cargamos en HL el valor del contador
    dec l                                           ;; Le restamos 1 para ver si da 0
    jr z, animar_enemigos                           ;;si da 0 continuamos con el codigo
        ld (contadorEnemigo), hl                    ;; si NO da 0 guardamos el valor de hl en el contador (HL = CONTADOR -1) 
        jp Fin_animacion_global                     ;; saltamos al final 

    animar_enemigos:
    ld hl, #0004
    ld (contadorEnemigo), hl
    
    call sys_animations_enemy

    ld a, (#entity_num)
    ld b, a                                        ;; cargamos en A el numero de entidades
    ld de, #entity_size                             ;; cargamos en BC el tamanyo de cada entidad

    ld ix, #enemy
    animar_siguiente_enem:

        ld a, e_nk_r(ix)
        cp #0
        jr z, no_sprite
        
        call camb_Sprite_Enem

        no_sprite:
        add ix, de

    djnz animar_siguiente_enem
    
    Fin_animacion_global:

ret

sys_animations_enemy:

    ld bc, (last_sprite_Enemigo)            ;; Si da 0 significa que nos movemos a la derecha, para saber que frame animamos, cargamos en BC el sprite anterior
    ld a, c                                 ;; Movemos C a A para realizar calculos mas facilmente
    cp #01                                  ;; le restamos a A 1
    jr z, animar_Frame_0_enemigo            ;; Si da 0 Significa que estamos en el frame 1, asi que ahora tocaria animar el frame 0
        ld c, #01                           ;; Si no da 0 significa que estamos en el frame 0, asi que ahora tocaria animar el frame 1
        jr Fin_animacion_enemigo            ;; Saltamos al final ya que hemos terminado

    animar_Frame_0_enemigo:                 ;; Si llegamos aqui significa que tenemos que animar el frame 0, por lo que lo cargamos en C y finalizamos el metodo
        ld c, #00
        jr Fin_animacion_enemigo

    Fin_animacion_enemigo:

    ld (last_sprite_Enemigo), bc
    
ret


sys_animations_player:
    ld h, e_prev_vx(ix)                             ;; Cargamos en HL las velocidades previas
    ld l, e_prev_vy(ix)                 

    ld b, e_vx(ix)                                  ;; Cargamos en BC las velocidades actuales
    ld c, e_vy(ix) 
    
    ;; SITUACIONES QUE DEBEN IGNORAR EL DELAY
        ;; CAMBIAR DIRECCION
        ;; PARARSE
    call Cambio_Direccion

    call mantener_player_quieto
    ld a, e
    cp #00
    jr z, comprobar_parar
        ld hl, #0001
        ld (contador), hl
        jr Fin_Animacion_Mov

    comprobar_parar:

    call parar_player
    ld a, e
    cp #00
    jr z, continuacion_animacion_empezar_cont
        ld hl, #0001
        ld (contador), hl
        jr Fin_Animacion_Mov
    

    continuacion_animacion_empezar_cont:

    ld hl, (contador)                               ;; Cargamos en HL el valor del contador
    dec l                                           ;; Le restamos 1 para ver si da 0
    jr z, continuacion_animacion_contador           ;; si da 0 continuamos con el codigo
        ld (contador), hl                           ;; si NO da 0 guardamos el valor de hl en el contador (HL = CONTADOR -1) 
        jp Fin_animacion_contador                   ;; saltamos al final 

    continuacion_animacion_contador: 

    ld hl, #0004
    ld (contador), hl                              ;; Reiniciamos el contador

    ld h, e_prev_vx(ix)                             ;; Cargamos en HL las velocidades previas
    ld l, e_prev_vy(ix)                 

    ld b, e_vx(ix)                                  ;; Cargamos en BC las velocidades actuales
    ld c, e_vy(ix) 

    

    ;;En Movimiento
        
    call animar_player
    jr Fin_Animacion_Mov



;; 5 SITUACIONES DIFERENTES
;; 1a : En reposo               (mantener el sprite en la posicion que estaba)  (velocidad actual = velocidad anterior = 0)
;; 2a : Nos empezamos a mover   (no tener delay)                                (velocidad actual != 0 velocidad anterior = 0)
;; 3a : Nos paramos             (mantener el sprite anterior)                   (Velocidad actual = 0 velocidad anterior != 0)
;; 4a : Seguimos en movimiento  (Animacion de verdad)                           (Velocidad actual = velocidad anterior != 0)            HECHO 100%
;; 5a : Cambio de direccion     (Cambiar de direccion sin lag)                  (Velocidad actual != Velocidad anterior y ambas != 0)   HECHO 100%


    Fin_animacion_contador:
        ;;TEMPORAL
        ld bc, (last_sprite)
        ;;TEMPORAL

    Fin_comprobacion_cambioDir:
    Fin_Animacion_Mov:
        ld (last_sprite), bc

    call camb_Sprite_player     ;; llamamos al manejador de entidades para que lo cambie

ret




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: Cambia el sprite para que apunte a la direcicon en la que se mueve el player
;;NECESITA: IX (direccion a la entidad), HL(Velocidad previa de la entidad), BC(Velocidad actual de la entidad)
;;MODIFICA: HL, A, BC
;;RETURNS: C (Id del sprite a animar)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Cambio_Direccion:
                                         

        ld a, b                                         ;; Cargamos en A la velocidad X y comprobamos si es 0
        cp #00          
        jr z, CambioDir_EjeY                            ;; Si la velocidad es 0 comprobamos el Eje Y

            cp h                                        ;; Le restamos a la velocidad X actual la pasada
            jr z, continuarCodigo                       ;; Si da 0 significa que la velocidad es la misma y no debemos continuar comprobando este eje 

                cp #01                                  ;; Comprobamos si nos estamos moviendo a la derecha restandole 1
                jr nz, CambioDir_Izq                    ;; Si no da 0 comprobamos si nos estamos moviendo a la derecha
                    ld c, #00                            ;; Si da 0 significa que nos estamos moviendo a la derecha ahora y tenemos que cargar el sprite numero 0 en C
                    jr Fin_comprobacion_cambioDir       ;; Una vez cargado el valor en C saltamos al final 

                CambioDir_Izq:
                cp #-1                                  ;; Comprobamos si nos estamos moviendo a la izquierda sumandole 1
                jr nz, CambioDir_EjeY                   ;; Si no da 0 comprobamos si nos estamos moviendo a la izquierda
                    ld c, #02                            ;; Si da 0 significa que nos estamos moviendo a la izquierda ahora y tenemos que cargar el sprite numero 2 en C
                    jr Fin_comprobacion_cambioDir       ;; Una vez cargado el valor en C saltamos al final 

        CambioDir_EjeY:            
        ld a, c                                         ;; Cargamos en A la velocidad en el eje Y y comprom¡bamos si es 0
        cp #00
        jr z, continuarCodigo                           ;; Si da 0 continuamos con el codigo 

            cp l                                        ;; Le restamos a la velocidad Y actual la pasada
            jr z, continuarCodigo                       ;; Si da 0 significa que la velocidad es la misma y continuamos con el codigo
        
                cp #02                                  ;; Comprobamos si nos estamos moviendo abajo restandole 2
                jr nz, cambioDir_arb                    ;; Si no da 0 comprobamos si nos estamos moviendo arriba
                    ld c, #04                            ;; Si da 0 significa que nos estamos moviendo abajo ahora y tenemos que cargar el sprite numero 4 en C
                    jr Fin_comprobacion_cambioDir       ;; Una vez cargado el valor en C saltamos al final

                cambioDir_arb:
                cp #-2                                  ;; Comprobamos si nos estamos moviendo abajo sumandole 2
                jr nz, continuarCodigo                  ;; Si no da 0 continuamos con el codigo
                    ld c, #06                           ;; Si da 0 significa que nos estamos moviendo arriba ahora y tenemos que cargar el sprite numero 6 en C
                    jr Fin_comprobacion_cambioDir       ;; Una vez cargado el valor en C saltamos al final

        continuarCodigo:
ret	


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: Hace el cambio entre sprites mientras te mueves en una direccion
;;NECESITA: IX (direccion a la entidad)
;;MODIFICA: HL, A, BC
;;RETURNS: C (Id del sprite a animar)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

animar_player:            
 

    ld h, e_vx(ix)                                  ;; Cargamos en BC las velocidades actuales
    ld l, e_vy(ix)

    ld a, h                                         ;; Cargamos en A la velocidad actual en el Eje X 
    cp #00                                          ;; Comprobamos si es 0
    jr z, Comprobar_Animacion_Y                     ;; Si es 0 pasamos a comprobar la velocidad en el ejeY
        

        cp #01                                      ;; COMPROBACION DERECHA: restamos 1 a la velocidad actual
        jr nz, comprobar_Animacion_Izq              ;; Si no da 0 significa que no nos estamos moviendo a la derecha, asi que saltamos a comprobar la izquierda
            ld bc, (last_sprite)                    ;; Si da 0 significa que nos movemos a la derecha, para saber que frame animamos, cargamos en BC el sprite anterior
            ld a, c                                 ;; Movemos C a A para realizar calculos mas facilmente
            cp #01                                  ;; le restamos a A 1
            jr z, animar_Frame_0                    ;; Si da 0 Significa que estamos en el frame 1, asi que ahora tocaria animar el frame 0
                ld c, #01                           ;; Si no da 0 significa que estamos en el frame 0, asi que ahora tocaria animar el frame 1
                jr Fin_Animacion                    ;; Saltamos al final ya que hemos terminado

            animar_Frame_0:                         ;; Si llegamos aqui significa que tenemos que animar el frame 0, por lo que lo cargamos en C y finalizamos el metodo
                ld c, #00
                jr Fin_Animacion

        comprobar_Animacion_Izq:                    ;; Procedemos a comprobar la animacion en la izquierda
            ld bc, (last_sprite)                    ;; Si entramos aqui sabemos que nos estamos moviendo a la izquierda 100%, asi que sencillamente debemos saber que frame animar
            ld a, c                                 ;; Movemos C a A para realizar calculos mas facilmente
            cp #03                                  ;; le restamos a A 3
            jr z, animar_Frame_2                    ;; Si da 0 Significa que estamos en el frame 3, asi que ahora tocaria animar el frame 2
                ld c, #03                           ;; Si no da 0 significa que estamos en el frame 2, asi que ahora tocaria animar el frame 3
                jr Fin_Animacion                    ;; Saltamos al final ya que hemos terminado

            animar_Frame_2:                         ;; Si llegamos aqui significa que tenemos que animar el frame 2, por lo que lo cargamos en C y finalizamos el metodo
                ld c, #02
                jr Fin_Animacion


    Comprobar_Animacion_Y:                          ;; Hacemos los mismos pasos que en el eje X pero esta vez en el eje Y
    ld a, l
    cp #00
    jr z, Fin_Animacion                             ;; Esta vez si da 0 saltamos directamente al final del metodo sin hacer nada

        cp #02                                      ;; COMPROBACION ABAJO: restamos 2 a la velocidad actual
        jr nz, comprobar_Animacion_Arb              ;; Si no da 0 significa que no nos estamos moviendo arriba, asi que saltamos a comprobar arriba
            ld bc, (last_sprite)                    ;; Si da 0 significa que nos movemos abajo, para saber que frame animamos, cargamos en BC el sprite anterior
            ld a, c                                 ;; Movemos C a A para realizar calculos mas facilmente
            cp #05                                  ;; le restamos a A 5
            jr z, animar_Frame_4                    ;; Si da 0 Significa que estamos en el frame 5, asi que ahora tocaria animar el frame 4
                ld c, #05                           ;; Si no da 0 significa que estamos en el frame 4, asi que ahora tocaria animar el frame 5
                jr Fin_Animacion                    ;; Saltamos al final ya que hemos terminado

            animar_Frame_4:                         ;; Si llegamos aqui significa que tenemos que animar el frame 4, por lo que lo cargamos en C y finalizamos el metodo
                ld c, #04
                jr Fin_Animacion

        comprobar_Animacion_Arb:                    ;; Procedemos a comprobar la animacion hacia arriba
            ld bc, (last_sprite)                    ;; Si entramos aqui sabemos que nos estamos moviendo arriba 100%, asi que sencillamente debemos saber que frame animar
            ld a, c                                 ;; Movemos C a A para realizar calculos mas facilmente
            cp #07                                  ;; le restamos a A 7
            jr z, animar_Frame_6                    ;; Si da 0 Significa que estamos en el frame 7, asi que ahora tocaria animar el frame 6
                ld c, #07                           ;; Si no da 0 significa que estamos en el frame 6, asi que ahora tocaria animar el frame 7
                jr Fin_Animacion                    ;; Saltamos al final ya que hemos terminado

            animar_Frame_6:                         ;; Si llegamos aqui significa que tenemos que animar el frame 6, por lo que lo cargamos en C y finalizamos el metodo
                ld c, #06
                jr Fin_Animacion

    Fin_Animacion:
ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: Hace que si nos paramos nos quedamos mirando hacia la direccion hacia la que nos moviamos
;;NECESITA: IX (direccion a la entidad)
;;MODIFICA: HL, A, BC
;;RETURNS: C (Id del sprite a animar), E, (1 = NO COMPROBAR ANIMACION EN MOVIMIENTO, 0 COMPROBARLA)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
parar_player:

    ld h, e_prev_vx(ix)                             ;; Cargamos en HL las velocidades previas
    ld l, e_prev_vy(ix)                 

    ld b, e_vx(ix)                                  ;; Cargamos en BC las velocidades actuales
    ld c, e_vy(ix)

    ld a, h                                         ;; Cargamos en A la velocidad X anterior del player
    cp #00                                          ;; Comprobamos si es 0
    jr z, comprobar_Eje_y_Parado                    ;; Si es 0 comprobamos el eje Y
        ld a, b                                     ;; Si no es 0 significa que antes nos estabamos moviendo en X, ahora comprobaremos si nos hemos dejado de mover en X
        cp #00
        jr nz, comprobar_Eje_y_Parado               ;; Si no es 0 significa que nos estamos moviendo en el eje X y pasamos a comprobar el eje Y
            ld a, h                                 ;; Si es 0 significa que ya no nos estamos 
            cp #01                                  ;; Le estamos 1 para saber si nos movemos a la derecha o a la izquierda
            jr nz, cargar_sprite_2_parado           ;; Si no da 0 significa que la velocidad es -1 (nos movemos a la izquierda)
                ld c, #00                           ;; si da 0 significa que la velocidad es 1 (nos movemos a la derecha), asi que cargaremos el sprite 0 en c y saldremos del metodo
                ld e, #01
                jr Fin_metodo_parado                
                
            cargar_sprite_2_parado:                 ;; cargaremos el sprite 0 en c y saldremos del metodo
                ld c, #02      
                ld e, #01                     
                jr Fin_metodo_parado

    comprobar_Eje_y_Parado:
    ld a, l                                         ;; Cargamos en A la velocidad X anterior del player
    cp #00                                          ;; Comprobamos si es 0
    jr z, Fin_metodo_parado_no_cambio               ;; Si es 0 comprobamos el eje Y
        ld a, c                                     ;; Si no es 0 significa que antes nos estabamos moviendo en X, ahora comprobaremos si nos hemos dejado de mover en X
        cp #00
        jr nz, Fin_metodo_parado_no_cambio          ;; Si no es 0 significa que nos estamos moviendo en el eje X y pasamos a comprobar el eje Y
            ld a, l                                 ;; Si es 0 significa que ya no nos estamos 
            cp #02                                  ;; Le estamos 1 para saber si nos movemos a la derecha o a la izquierda
            jr nz, cargar_sprite_6_parado           ;; Si no da 0 significa que la velocidad es -1 (nos movemos a la izquierda)
                ld c, #04                           ;; si da 0 significa que la velocidad es 1 (nos movemos a la derecha), asi que cargaremos el sprite 0 en c y saldremos del metodo
                ld e, #01
                jr Fin_metodo_parado                
                
            cargar_sprite_6_parado:                 ;; cargaremos el sprite 0 en c y saldremos del metodo
                ld c, #06                           
                ld e, #01
                jr Fin_metodo_parado
    
    Fin_metodo_parado_no_cambio:
    ld e, #00

    Fin_metodo_parado:

ret	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: Hace que si nos paramos nos quedamos mirando hacia la direccion hacia la que nos moviamos
;;NECESITA: IX (direccion a la entidad)
;;MODIFICA: HL, A, BC
;;RETURNS: C (Id del sprite a animar), E, (1 = NO COMPROBAR ANIMACION EN MOVIMIENTO, 0 COMPROBARLA)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mantener_player_quieto:

    ld h, e_prev_vx(ix)                             ;; Cargamos en HL las velocidades previas
    ld l, e_prev_vy(ix)                 

    ld b, e_vx(ix)                                  ;; Cargamos en BC las velocidades actuales
    ld c, e_vy(ix)

    ld a, h                                         ;; literalmente comprobamos si todas las velocidades son 0, si lo son copiamos el frame anterior en BC y salimos del metodo
    cp #00
    jr nz, fin_metodo_quieto_no_cambio
        ld a, b
        cp #00
        jr nz, fin_metodo_quieto_no_cambio
            ld a, l
            cp #00
            jr nz, fin_metodo_quieto_no_cambio
                ld a, c
                cp #00
                jr nz, fin_metodo_quieto_no_cambio
                    ld bc, (last_sprite)
                    ld e, #01
                    jr fin_metodo_quieto


    fin_metodo_quieto_no_cambio:
    ld e, #00

    fin_metodo_quieto:
ret	