.include "cpctelera.h.s"
.include "../cpct_header.h.s"
.include "../managers/man_entity.h.s"
.include "sys_render.h.s"
.include "../maps/lvl0/lvl0_pack.h.s"
.include "sys_collisions.h.s"
.include "../managers/man_maps.h.s"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: dibuja al personaje //mover a render
;;NECESITA: IX (direccion al jugador)
;;MODIFICA: A, HL, BC, DE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

erase_enemies:
;    ld de, #0xC000
;    ld c, e_prev_x(ix)
;    ld b, e_prev_y(ix)
;    call cpct_getScreenPtr_asm
    ;dibuja el sprite

    ld d, e_prev_x(ix)
    ld e, e_prev_y(ix)
    ld a, #03
    ld b, e_h(ix)
    ld c, e_w(ix)
    call cpct_drawSolidBox_asm
ret	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: dibuja un cuadrado sobre la posicion del la entidad en IY
;;NECESITA: IY (direccion a entidad)
;;MODIFICA: DE, BC, A, HL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
erase_enemies_IY:
    ld de, #0xC000
    ld c, e_x(iy)
    ld b, e_y(iy)
    call cpct_getScreenPtr_asm
    ;dibuja el sprite

    ex de, hl
    ld a, #03
    ld b, e_h(iy)
    ld c, e_w(iy)
    call cpct_drawSolidBox_asm

ret	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: dibuja al personaje //mover a render
;;NECESITA: IX (direccion al jugador)
;;MODIFICA: A, HL, BC, DE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

sys_render:
    
    
;    ;carga posicion de personaje en hl
;    ld de, #0xC000
;    ld c, e_x(ix)
;    ld b, e_y(ix)
;    call cpct_getScreenPtr_asm 
    ;dibuja el sprite

    ld d, e_mem_pos_h(ix)
    ld e, e_mem_pos_l(ix)
    ld l, e_sp_l(ix)
    ld h, e_sp_h(ix)
    ld b, e_h(ix)
    ld c, e_w(ix)
    call cpct_drawSprite_asm

ret

pintar_enemy:
    ld ix, #player
    call erase_enemies
    call sys_render

    ld ix, #enemy
    ld a, e_nk_r(ix)
    cp #0
    jr z, jump1
        call erase_enemies
        call sys_render
    jump1:

    ld ix, #enemy2
    ld a, e_nk_r(ix)
    cp #0
    jr z, jump2
        call erase_enemies
        call sys_render
    jump2:

    ld ix, #enemy3
    ld a, e_nk_r(ix)
    cp #0
    jr z, jump3
        call erase_enemies
        call sys_render
    jump3:

    ld ix, #enemy4
    ld a, e_nk_r(ix)
    cp #0
    jr z, jump4
        call erase_enemies
        call sys_render
    jump4:

    ld ix, #enemy5
    ld a, e_nk_r(ix)
    cp #0
    jr z, jump5
        call erase_enemies
        call sys_render
    jump5:

    ld ix, #enemy6
    ld a, e_nk_r(ix)
    cp #0
    jr z, jump6
        call erase_enemies
        call sys_render
    jump6:
    
;    ld a,(#entity_num)
;    ld b, a
;    update_next_:
;        ld de, #entity_size
;        add ix, de
;
;        ld a, e_nk_r(ix)
;        cp #0
;        jr z, jump_
;            push bc
;                call erase_enemies
;                call sys_render
;            pop bc
;        jump_:
;    djnz update_next_

ret	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: borra la pantalla para montar las pantallas de estado
;;NECESITA: HL (color de paleta uno en cada byte)
;;MODIFICA: HL, A, DE, BC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sys_render_cleanScreen:
          ;OVERRIDE MEMORY VIDEO == CLEAN SCREEN
   call cpct_px2byteM0_asm ;conver from palete position to real value
   ld a, l ;output l to a
   ld hl, #CPCT_VMEM_START_ASM
   ld d, a
   ld e, a
   ld bc, #0x4000
   call cpct_memset_f64_asm ;; copy colo calculated to every memory position
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: dibuja el mapa
;;NECESITA: 
;;MODIFICA: 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

sys_render_maps:

   ld  hl, #0xC000
   ld de, #tilemap_ptr
   call cpct_etm_drawTilemap4x8_ag_asm

ret